/*!
 * \file        log.h
 * \brief       Protótipos e esqueletos para o módulo log.c
 *
 * \date        07/05/12 16:23
 * \version     0.0.1
 * \author      Alessandro Elias, ae11@inf.ufpr.br
 * \author      Ruanito Diego Santos, rds@inf.ufpr.br
 */

#ifndef __MYLOG_H__
#define __MYLOG_H__       1

#include <stdio.h>
#include <mycommdef.h>

/*! Prefixo do nome do arquivo de log. */
#define FILE_NAME               "log"
/*! Sufixo do nome do arquivo de log. */
#define FILE_EXTENTION          ".txt"
/*! Numero maximo de logs que pode existir em um mesmo diretorio. */
#define MAX_LOGS                999
/*! Tamanho em bytes (char's) necessário para gerar o número como strings (999 3 chars). */
#define SIZE_OF_COMPLEMENT      3

/*
 * Defina somente dentro do font log.c onde será alocada globalmente.
 * Outros modulos devem fazer referência a mesma váriavel.
 */
#ifdef _DECLARE_VAR_STREAMLOG_
FILE *g_StreamLog = NULL;       /*! Stream do arquivo de log. */
#else
extern FILE *g_StreamLog;       /*!< Referência para o stream do arquivo de log. */
#endif

bool    OpenLog(void);
void    CloseLog(void);
char    *GetLogFileName(void);
int     LogMessage(const char*, ...);

#endif /* __LOG_H__ */
