/*!
 * \file		mydebug.h
 * \brief		Declarações que facilita a depuração de código.
 *
 * \date		26/04/12 11:13
 * \version		0.0.1
 * \author		Alessandro Elias, ae11@inf.ufpr.br
 * \author		Ruanito Diego Santos, ae11@inf.ufpr.br
 */
 
 
#ifndef __MYDEBUG_H__
#define __MYDEBUG_H__       1

#ifdef DEBUG
/*! Expande macro, parâmetro x para string. */
#define STRLN(x)        #x
/*! Obtém x como string */
#define STRLN_(x)       STRLN(x)
/*! Constrói mesagem para stderr com linha onde ocorreu. */
#define PERRLN(msg)     perror( msg " Linha(" STRLN_(__LINE__) ")")

#else	/* se nao estiver definido DEBUG compilation */

/*! Apenas chame mensagem de erro so sistema. */
#define PERRLN(msg)     perror((msg))

#endif /* DEBUG */

#endif /* __MYDEBUG_H__ */

